/*
 * Copyright Justin Armstrong 2004. 
 *
 * This file is part of the application "Weather"
 * 
 * "Weather" is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Weather is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */



#ifndef CONSTANTS_H
#define CONSTANTS_H


#define ELocationNameLength 30

enum TCompassDirection
    {

    ECompassN, 
    ECompassNNE,
    ECompassNE,
    ECompassENE,

    ECompassE,
    ECompassESE,
    ECompassSE,
    ECompassSSE,
    
    ECompassS,
    ECompassSSW,
    ECompassSW,
    ECompassWSW,
    
    ECompassW,
    ECompassWNW,
    ECompassNW,
    ECompassNNW,

    ECompassError
    };



enum TTemperatureUnit
    {
    ECentigrade,
    EFahrenheit
    };

enum TSpeedUnit
    {
    EKnots,
    EKph,
    EMph,
    EMps    //metres per second
    };

enum TDistanceUnit
    {
    EMiles,
    EKilometres
    };

enum TCloudReport
    {
    ECloudSummary,
    ECloudDetailed
    };


enum TPhenomenon
    {
    EDz,    //drizzle
    ERa,    //rain
    ESn,    //snow
    ESg,    //snow grains
    EIc,    //ice crystals
    EPe,    //ice pellets
    EGr,    //hail
    EGs,    //small hail pellets
    EUp,    //unknown precipitation
    EBr,    //mist
    EFg,    //fog
    EFu,    //smoke
    EVa,    //volcanic ash
    EDu,    //widespread dust
    ESa,    //sand
    EHz,    //haze
    EPy,    //spray
    EPo,    //dust swirls
    ESq,    //squall
    EFc,    //funnel cloud
    ESs,    //sand storm
    EDs     //dust storm
    };



enum TPhenomenonModifier
    {
    ENoMod, //(no modifier)
    EMi,    //shallow
    EPr,    //partial
    EBc,    //patches
    EDr,    //low drifting
    EBl,    //blowing
    ESh,    //showers
    ETh,    //thunderstorm
    EFz    //freezing
    };



enum TCloudCoverage
    {
    EClr,   //clear sky
    ESkc,   //clear sky
    ECavok,  //clear sky
    EFew,   //few clouds
    ESct,   //scattered clouds
    EBkn,   //broken clouds
    EOvc   //overcast
    };


enum TIntensity
    {
    ELight,
    EModerate,
    EHeavy,
    EVicinity

    };


#endif