
/*
 * Copyright Justin Armstrong 2004. 
 *
 * This file is part of the application "Weather"
 * 
 * "Weather" is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Weather is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */


#ifndef LOCATION_H
#define LOCATION_H

#include <eikapp.h>
#include <aknapp.h>

#include "constants.h"
#include "weatherappui.h"

class CLocationForm;
class CWeatherAppUi;

class CLocation : public CBase  
    {
    public:
	CLocation();
    CLocation(TDesC& aIcaoCode, TDesC& aName);
    virtual ~CLocation();

    void ConstructFromStreamL(RDictionaryReadStream& readStream);
    void SaveL(RDictionaryWriteStream& writeStream);

    void ParseReportL(HBufC* reportString);

    CWeatherInfo* Report();
    TDesC& Name();
    TDesC& IcaoCode();

    friend class CLocationForm;
    friend class CWeatherAppUi;

    
    TBuf<ELocationNameLength> iName;

    private:
    TBuf<4> iIcaoCode;

    HBufC* iLastReportString;   //the raw metar string
    CWeatherInfo* iLastReport;  //the parsed report

    };

#endif
