
/*
 * Copyright Justin Armstrong 2004. 
 *
 * This file is part of the application "Weather"
 * 
 * "Weather" is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Weather is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */


#ifndef WEATHERPARSER_H
#define WEATHERPARSER_H

#include <aknapp.h>
#include <aknappui.h>
#include <e32def.h>

#include "stringintdict.h"
#include "weatherinfo.h"


class CWeatherParser : public CBase  
    {
    public:

    static CWeatherParser* NewLC(CCoeEnv* aCoeEnv);

	CWeatherParser();
	virtual ~CWeatherParser();

    void ConstructL(CCoeEnv* aCoeEnv);

    CWeatherInfo* ParseReportL(TDesC& aMetarData);

    private:

    TBool ParseDateAndTime(TDesC& aDateParam);

    TCompassDirection CompassDirection(TInt degrees);
    TBool ParseWind(TDesC& aWindString);
    
    TBool ParseModifier(TDesC& aModParam);

    TBool ParseCloudCover(TDesC& aCloudString);
    
    TBool ParseTemp(TDesC& atempString);

    TBool ParseCondition(TDesC& aConditionString);    
    
    TBool ParsePressure(TDesC& aPressureParam);

    TBool ParseVisibilty(TDesC& aVisParam);

    CWeatherInfo* iWeatherReport;


    CStringIntDict* iPhenomenonDict;
    CStringIntDict* iCloudDict;
    CStringIntDict* iModifierDict;

    };

#endif