
/*
 * Copyright Justin Armstrong 2004. 
 *
 * This file is part of the application "Weather"
 * 
 * "Weather" is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Weather is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */


#ifndef WEATHERUTILS_H
#define WEATHERUTILS_H

#include <aknapp.h>
#include "constants.h"
#include "weatherappui.h"

double MilesToMetres(TInt aMiles);
double MetresToMiles(TInt aMetres);
double FeetToMiles(TInt aFeet);
double FeetToMetres(TInt aFeet);

double KphToKnots(TInt aKph);
double MpsToKnots(TInt aMps);
double KnotsToKph(TInt aKnots);
double KnotsToMph(TInt aKnots);
double MphToKnots(TInt aMph);
double CentigradeToFahrenheit(TInt aCentigrade);

void MakeSpeedString(TDes& aString, TInt aKnots);
void MakeTempString(TDes& aString, TInt aCentigrade);

double RelativeHumidity(double aTemp, double aDewPoint);

#endif 
