
/*
 * Copyright Justin Armstrong 2004. 
 *
 * This file is part of the application "Weather"
 * 
 * "Weather" is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Weather is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include "location.h"


CLocation::CLocation(TDesC& aIcaoCode, TDesC& aName)
    {
    iIcaoCode = aIcaoCode;
    iName = aName;
    }

CLocation::CLocation()
    {
    }

void CLocation::ConstructFromStreamL(RDictionaryReadStream& readStream)
    {


    readStream >> iName;
    readStream >> iIcaoCode;

    TBool hasReport = readStream.ReadInt16L();
    if (hasReport)
        {
        iLastReportString = HBufC::NewL(readStream, 1000);

        iLastReport = GLOBALS->iParser->ParseReportL(*iLastReportString);
        }


    }

void CLocation::ParseReportL(HBufC* reportString)
    {
    
    if (iLastReportString) delete iLastReportString;
    if (iLastReport) delete iLastReport;
    iLastReportString = reportString;
    iLastReport = GLOBALS->iParser->ParseReportL(*reportString);

    }

void CLocation::SaveL(RDictionaryWriteStream& writeStream)
    {

    writeStream << iName;
    writeStream << iIcaoCode;

    if (iLastReportString)
        {
        writeStream.WriteInt16L(ETrue);
        writeStream << *iLastReportString;

        }
    else
        {
        writeStream.WriteInt16L(EFalse);
        }

    }

TDesC& CLocation::Name()
    {
    return iName;
    }

TDesC& CLocation::IcaoCode()
    {
    return iIcaoCode;
    }

CWeatherInfo* CLocation::Report()
    {
    return iLastReport;
    }


CLocation::~CLocation()
    {
    delete iLastReportString;
    delete iLastReport;
    }
