
/*
 * Copyright Justin Armstrong 2004. 
 *
 * This file is part of the application "Weather"
 * 
 * "Weather" is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Weather is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include "locationform.h"


CLocationForm* CLocationForm::NewL(CLocation* aLocation, CArrayPtrFlat<CLocation>* aLocationArray)
    {
    CLocationForm* self = 
        new (ELeave) CLocationForm(aLocation, aLocationArray);
    CleanupStack::PushL(self);
    self->ConstructL();
    CleanupStack::Pop();
    return self;
    }


CLocationForm::CLocationForm(CLocation* aLocation, CArrayPtrFlat<CLocation>* aLocationArray)
    {
    iLocation = aLocation;
    iLocationArray = aLocationArray;
    }

CLocationForm::~CLocationForm()
    {
    if (iOwnLocation) delete iLocation;
    }

void CLocationForm::ConstructL()
    {
    if (!iLocation)
        {
        iLocation = new (ELeave) CLocation;
        iOwnLocation = ETrue;
        }

    CAknForm::ConstructL();
    }


TBool CLocationForm::SaveFormDataL()
    {

    GetEdwinText(iLocation->iIcaoCode, EIcaoCodeEdwinId);
    GetEdwinText(iLocation->iName, ELocationNameEdwinId);

    if (iOwnLocation)
        {
        iOwnLocation = EFalse;
        iLocationArray->AppendL(iLocation);
        }

    return ETrue;
    }


void CLocationForm::PostLayoutDynInitL()
    {
    CAknForm::PostLayoutDynInitL();

    SetEdwinTextL(EIcaoCodeEdwinId, &(iLocation->iIcaoCode));
    SetEdwinTextL(ELocationNameEdwinId, &(iLocation->iName));


    }

