
/*
 * Copyright Justin Armstrong 2004. 
 *
 * This file is part of the application "Weather"
 * 
 * "Weather" is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Weather is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include "usersettingsdialog.h"


CUserSettingsDialog::CUserSettingsDialog(CWeatherAppUi* aAppUi) : CAknDialog()
    {
    iAppUi = aAppUi;
    }

void CUserSettingsDialog::ConstructL()
    {

    iListBox = new (ELeave) CUserSettingsList();

    iListBox->SetContainerWindowL(*this);
    iListBox->ConstructFromResourceL(R_SETTING_LIST_USER_SETTINGS);

    iListBox->MakeVisible(ETrue);

    iEikonEnv->EikAppUi()->AddToStackL(iListBox);
    iListBox->SetFocus(ETrue);

    iListBox->ActivateL();
    DrawNow();
    
    
    }

CUserSettingsDialog::~CUserSettingsDialog()
    {
    iEikonEnv->EikAppUi()->RemoveFromStack(iListBox);

    delete iListBox;

    }


void CUserSettingsDialog::ActivateL()
    {
    CAknDialog::ActivateL();
    iListBox->ActivateL();
    }


TInt CUserSettingsDialog::CountComponentControls() const
    {
    return 1;
    }


CCoeControl* CUserSettingsDialog::ComponentControl(TInt aIndex) const
    {

    switch ( aIndex )
        {
        case 0:
            return iListBox;
        default:
            return NULL;
        }
    
    }


TKeyResponse CUserSettingsDialog::OfferKeyEventL(
    const TKeyEvent&/* aKeyEvent*/,
    TEventCode/* aType */)
    {
    RDebug::Print(_L("!!OfferKeyEventL"));
    return EKeyWasNotConsumed;
    }


TBool CUserSettingsDialog::OkToExitL( TInt aKeycode)
    {

    RDebug::Print(_L("!!OkToExitL"));
    switch(aKeycode)
        {
       case EAknSoftkeyBack:
            {
            iListBox->UpdateUserL();
            RDebug::Print(_L("EAknSoftkeyBack pressed"));

            iAppUi->SaveUserSettingsL();
            iAppUi->DisplayLocation();


            break;
            }
       case EAknSoftkeyOk:
            {
            RDebug::Print(_L("EAknSoftkeyOk pressed"));
            iListBox->HandleListBoxEventL(iListBox->ListBox(), MEikListBoxObserver::EEventEnterKeyPressed);
            return EFalse;
            break;
            }
        default:
            break;
        }
    return ETrue;
    }
